import { CodeGen } from '@volar/code-gen';
import * as CompilerCore from '@vue/compiler-core';
import * as CompilerDOM from '@vue/compiler-dom';
import { EmbeddedFileMappingData } from '../sourceFile';
import { ResolvedVueCompilerOptions } from '../types';
export declare function isIntrinsicElement(runtimeMode: 'runtime-dom' | 'runtime-uni-app', tag: string): boolean;
export declare function generate(ts: typeof import('typescript/lib/tsserverlibrary'), vueCompilerOptions: ResolvedVueCompilerOptions, sourceTemplate: string, sourceLang: string, templateAst: CompilerDOM.RootNode, hasScriptSetup: boolean, cssScopedClasses?: string[]): {
    codeGen: CodeGen<EmbeddedFileMappingData>;
    formatCodeGen: CodeGen<EmbeddedFileMappingData>;
    cssCodeGen: CodeGen<EmbeddedFileMappingData>;
    tagNames: Record<string, number[]>;
    identifiers: Set<string>;
    slotsNum: number;
};
export declare function walkElementNodes(node: CompilerDOM.RootNode | CompilerDOM.TemplateChildNode, cb: (node: CompilerDOM.ElementNode) => void): void;
export declare function getPatchForSlotNode(node: CompilerDOM.ElementNode): CompilerCore.ForNode | undefined;
